##############################################################################
#
# Copyright (c) 2011 Nexedi SARL and Contributors. All Rights Reserved.
#                     Kazuhiko <kazuhiko@nexedi.com>
#                     Rafael Monnerat <rafael@nexedi.com>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################
import unittest

from Products.ERP5Type.tests.ERP5TypeFunctionalTestCase import ERP5TypeFunctionalTestCase
from erp5.component.test.testOfficeJSAppstoreMixin import \
  testOfficeJSAppstoreMixin

class TestOfficejSAppstoreUI(testOfficeJSAppstoreMixin, ERP5TypeFunctionalTestCase):
  foreground = 0
  run_only = "officejs_appstore_ui_zuite"

  def afterSetUp(self):
    ERP5TypeFunctionalTestCase.afterSetUp(self)
    testOfficeJSAppstoreMixin.afterSetUp(self)
    self.portal.portal_preferences.getActiveSystemPreference().edit(
      preferred_credential_alarm_automatic_call=1,
      preferred_credential_recovery_automatic_approval=1,
      preferred_credential_request_automatic_approval=1
    )
    self.tic()

def test_suite():
  suite = unittest.TestSuite()
  suite.addTest(unittest.makeSuite(TestOfficejSAppstoreUI))
  return suite