# test_suite is provided by 'run_test_suite'
from glob import glob
from test_suite import SavedTestSuite
import os, subprocess, re
import sys


class OfficeJS(SavedTestSuite):
    """
    """
    _saved_test_id = "officejs_test:testOfficeJSAppstoreMixin"
    def getTestList(self):
      test_list = []
      path = sys.path[0]
      component_re = re.compile(".*/([^/]+)/TestTemplateItem/portal_components"
                           "/test\.[^.]+\.([^.]+).py$")

      for test_path in (
         glob('%s/bt5/*/TestTemplateItem/portal_components/test.ojs.*.py' % path) +
         glob('%s/bt5/*/TestTemplateItem/portal_components/test.erp5.testFunctionalOfficeJSAppstore*.py' % path) +
         glob('%s/bt5/*/TestTemplateItem/portal_components/test.*.testOfficeJS*.py' % path)
         ):
        component_re_match = component_re.match(test_path)
        if component_re_match is not None:
          test_case = "%s:%s" % (component_re_match.group(1),
                               component_re_match.group(2))
        else:
          test_case = test_path.split(os.sep)[-1][:-3] # remove .py
        test_list.append(test_case)

      return test_list